# The Algorithms - JavaScript

<!-- Front Matter -->
JavaScript Repository of TheAlgorithms, which implements various algorithms and data structures in JavaScript.

<div align="center">

  [![JavaScript Banner][banner]](DIRECTORY.md)

  [![Checks][checks]][actions]
  [![Contributions Welcome][welcome]](CONTRIBUTING.md)
  [![standard.js][standard-logo]][standard-js]
  [![Discord chat][chat]][discord-server]

  
</div>

---

<!-- Disclaimer -->

<h4 align="center">
  These implementations are for demonstrative purposes only. Dedicated implementations of these algorithms and data
  structures are much better for performance and security reasons. We also do not provide any guarantee for api stability.
</h4>

---

<!-- Body -->

Before contributing to this repository, make sure to read our [Contribution Guidelines](CONTRIBUTING.md). You can look
at other [TheAlgorithms Repositories][repositories] or the [issues with a "help wanted" label][help-wanted] for
inspiration regarding what to implement. Our maintainers will guide you through how to make your contribution properly
if you make any mistakes. The names of the maintainers of this repository are listed in the
[CODEOWNERS file](.github/CODEOWNERS).

You can find a list of the algorithms currently in the repository in the [directory](DIRECTORY.md). Explanations of
many of the algorithms can be found in the [wiki][explanation].

---

<!-- Banner Image -->
[banner]: https://user-images.githubusercontent.com/68542775/167072911-dc31eac8-6885-4a05-9c25-279ecce22a79.png

<!-- Badge Links -->
[standard-logo]: https://img.shields.io/badge/code%20style-standardjs-%23f3df49
[chat]: https://img.shields.io/discord/808045925556682782.svg?logo=discord&colorB=7289DA
[welcome]: https://img.shields.io/static/v1.svg?label=Contributions&message=Welcome&color=0059b3
[checks]: https://img.shields.io/github/actions/workflow/status/TheAlgorithms/JavaScript/Ci.yml?branch=master&label=checks
[grade]: https://img.shields.io/lgtm/grade/javascript/g/TheAlgorithms/JavaScript.svg?logo=lgtm&logoWidth=18

<!-- External Links -->
[standard-js]: https://standardjs.com/
[discord-server]: https://the-algorithms.com/discord/
[actions]: https://github.com/TheAlgorithms/JavaScript/actions
[explanation]: https://github.com/TheAlgorithms/JavaScript/wiki
[repositories]: https://github.com/orgs/TheAlgorithms/repositories
[help-wanted]: https://github.com/TheAlgorithms/JavaScript/issues?q=is%3Aopen+is%3Aissue+label%3A%22help+wanted%22
